/*
 * withtty VERSION: 0.2.1-mac
 * gcc withtty-mac.c -lutil -fno-stack-protector \
     -o withtty_v`sed -n "s/^.*withtty VERSION: \([0-9]\.[0-9]\.[0-9]\)[ ]*$/\1/p" withtty.c`_ppc_leopard
 *
 * FIXME: automate arch and glibc version in the compile line above too
 *
 * FIXME: need to verify that the write()'s to stdout complete
 * FIXME: encapsulate the read()'s
 */


/*
 *
 */
#include <fcntl.h>
#include <errno.h>
#include <util.h> /*#include <pty.h>*/
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <termios.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>


/*
 *
 */
#define BUF_SIZE 256


/*
 *
 */
typedef struct
{
   int fd;
   char buf[BUF_SIZE];
   int len;
} fd_buf;


/*
 * static declarations
 */
static int check_args(int argc, char **argv);
static void consume_lines(fd_buf *buf);
static void print_usage();
static int run_child();
static int run_su_master_loop(pid_t child_pid, fd_buf *buf);
static int run_sudo_master_loop(pid_t child_pid, fd_buf *buf, const char *prompt);
static int wait_for_echo_off(int pty_fd);
static void write_password_from_stdin(int pty_fd);


/*
 *
 */
int
main(int argc,
     char **argv)
{
   char *prompt;
   pid_t child_pid;
   fd_buf pty_master;
   /* ssize_t n; */
   /* char *newline_pos; */
   /* ssize_t linelen; */
   /* int i; */
   /* int child_status; */
   struct sigaction sigpipe_action;
   int r;


   /* */
   sigpipe_action.sa_handler = SIG_IGN;
   if (sigemptyset(&sigpipe_action.sa_mask) < 0)
   {
      printf("Error: unable to use sigemptyset() to set up SIGPIPE handler.\n");
      exit(1);
      return 1;
   }
   sigpipe_action.sa_flags = 0;
   if (sigaction(SIGPIPE, &sigpipe_action, NULL) < 0)
   {
      printf("Error: unable to use sigaction() to set SIGPIPE handler.\n");
      exit(1);
      return 1;
   }

   /* */
   if (!check_args(argc, argv))
   {
      print_usage();
      exit(1);
      return 1;
   }

   /* */
   prompt = argv[2];

   /* */
   pty_master.fd = -1;
   pty_master.len = 0;

   /* */
   child_pid = forkpty(&pty_master.fd, NULL, NULL, NULL);
   if (child_pid == 0)
   {
      return run_child(argc - 3, argv + 3);
   }

   /* */
   if (!strcmp(argv[1], "su"))
   {
      r = run_su_master_loop(child_pid, &pty_master);
      exit(r);
      return r;
   }
   else   /* !strcmp(argv[1], "sudo") is true */
   {
      r = run_sudo_master_loop(child_pid, &pty_master, prompt);
      exit(r);
      return r;
   }

   /* for (;;) */
   /* { */
   /*    n = read(pty_master.fd, pty_master.buf + pty_master.len, BUF_SIZE - 1 - pty_master.len); */
   /*    if (n < 0) */
   /*    { */
   /*       break; */
   /*    } */
   /*    pty_master.len += n; */

   /*    if (!strncmp(pty_master.buf, prompt, pty_master.len)) */
   /*    { */
   /*       if (!wait_for_echo_off(pty_master.fd)) */
   /*       { */
   /*          printf("Error: echo was not turned off (I expected it to be)\n"); */
   /*          exit(1); */
   /*          return 1; */
   /*       } */

   /*       write_password_from_stdin(pty_master.fd); */
   /*       break; */
   /*    } */

   /*    consume_lines(&pty_master); */
   /* } */

   /* for (;;) */
   /* { */
   /*    n = read(pty_master.fd, pty_master.buf + pty_master.len, BUF_SIZE - 1 - pty_master.len); */
   /*    if (n < 0) */
   /*    { */
   /*       break; */
   /*    } */
   /*    pty_master.len += n; */

   /*    if (!strncmp(pty_master.buf, prompt, pty_master.len)) */
   /*    { */
   /*       if (!wait_for_echo_off(pty_master.fd)) */
   /*       { */
   /*          continue; */
   /*       } */
   /*       else */
   /*       { */
   /*          close(pty_master.fd); */
   /*          waitpid(child_pid, &child_status, 0); */
   /*          return 1; */
   /*       } */
   /*    } */

   /*    consume_lines(&pty_master); */
   /* } */

   /* consume_lines(&pty_master); */

   /* /\* print non-line remainder, if any *\/ */
   /* write(1, pty_master.buf, pty_master.len); */

   /* /\* FIXME: check return value *\/ */
   /* waitpid(child_pid, &child_status, 0); */
   /* return WEXITSTATUS(child_status); */
}


/*
 *
 */
static int
check_args(int argc,
           char **argv)
{
   return (argc >= 4) && (!strcmp(argv[1], "su") || !strcmp(argv[1], "sudo"));
          
}


/*
 *
 */
static void consume_lines(fd_buf *buf)
{
   while (buf->len > 0)
   {
      char *newline_pos;

      buf->buf[buf->len] = '\0';
      newline_pos = strstr(buf->buf, "\n");
      if (newline_pos == NULL && buf->len == BUF_SIZE - 1)
      {
         printf("Error: line too long (longer than %d chars.)\n", BUF_SIZE - 1);
         exit(1);
         return;
      }
      else if (newline_pos != NULL)
      {
         write(1, buf->buf, newline_pos - buf->buf + 1);
         memcpy(buf->buf, newline_pos + 1, buf->len - (newline_pos - buf->buf + 1));
         buf->len -= newline_pos - buf->buf + 1;
      }
      else
      {
         break;
      }
   }
}


/*
 *
 */
static void
print_usage()
{
   /* FIXME FILLME */
   printf("Invalid args.\n");
}


/*
 *
 */
static int
run_child(int argc, char **argv)
{
   char **args;
   int i;

   args = (char**) malloc((argc + 1) * sizeof(char*));
   for (i = 0; i < argc; ++i)
   {
      args[i] = argv[i];
   }
   args[argc] = NULL;

   return execve(argv[0], args, NULL);
}


/*
 *
 */
static int
run_su_master_loop(pid_t child_pid,
                   fd_buf *buf)
{
   ssize_t n;
   int child_status;


   /* just read one buffer-ful; assume that's enough */
   buf->len = 0;
   n = read(buf->fd, buf->buf + buf->len, BUF_SIZE - 1 - buf->len);
   if (n <= 0)
   {
      /* */
   }
   buf->len += (n > 0) ? n : 0;

   /* */
   if (!wait_for_echo_off(buf->fd))
   {
      printf("Error: echo was not turned off (I expected it to be)\n");
      return 1;
   }

   /* */
   write_password_from_stdin(buf->fd);

   /* */
   consume_lines(buf);

   /* */
   for (;;)
   {
      n = read(buf->fd, buf->buf + buf->len, BUF_SIZE - 1 - buf->len);
      if (n <= 0)
      {
         break;
      }
      buf->len += n;

      consume_lines(buf);
   }
   
   /* */
   consume_lines(buf);

   /* print non-line remainder, if any */
   write(1, buf->buf, buf->len);

   /* FIXME: check return value */
   waitpid(child_pid, &child_status, 0);
   return WEXITSTATUS(child_status);
}


/*
 *
 */
static int
run_sudo_master_loop(pid_t child_pid,
                     fd_buf *buf,
                     const char *prompt)
{
   ssize_t n;
   int child_status;


   /* */
   for (;;)
   {
      n = read(buf->fd, buf->buf + buf->len, BUF_SIZE - 1 - buf->len);
      if (n <= 0)
      {
         break;
      }
      buf->len += n;

      if (!strncmp(buf->buf, prompt, buf->len))
      {
         if (!wait_for_echo_off(buf->fd))
         {
            printf("Error: echo was not turned off (I expected it to be)\n");
            return 1;
         }

         write_password_from_stdin(buf->fd);
         break;
      }

      consume_lines(buf);
   }

   /* */
   for (;;)
   {
      n = read(buf->fd, buf->buf + buf->len, BUF_SIZE - 1 - buf->len);
      if (n <= 0)
      {
         break;
      }
      buf->len += n;

      if (!strncmp(buf->buf, prompt, buf->len))
      {
         if (!wait_for_echo_off(buf->fd))
         {
            continue;
         }
         else
         {
            close(buf->fd);
            waitpid(child_pid, &child_status, 0);
            write(1, buf->buf, buf->len);   /* print non-line remainder, if any (i.e., the prompt) */
            return 1;
         }
      }

      consume_lines(buf);
   }

   /* */
   consume_lines(buf);

   /* print non-line remainder, if any */
   write(1, buf->buf, buf->len);

   /* FIXME: check return value */
   waitpid(child_pid, &child_status, 0);
   return WEXITSTATUS(child_status);
}


/*
 *
 */
static int
wait_for_echo_off(int pty_fd)
{
   int i;
   struct termios tio;


   tcgetattr(pty_fd, &tio);
   for (i = 0; (tio.c_lflag & ECHO) && i < 127; ++i)
   {
      usleep(1000);
      tcgetattr(pty_fd, &tio);
   }

   return !(tio.c_lflag & ECHO);
}


/*
 * read the password from stdin, and write it to pty_fd
 */
static void
write_password_from_stdin(int pty_fd)
{
   ssize_t n, plen, pw;
   char buf[BUF_SIZE];


   /* read the password from stdin */
   for (plen = 0; plen < BUF_SIZE - 1;)
   {
      n = read(0, buf + plen, BUF_SIZE - 1 - plen);
      if (n <= 0)
      {
         break;
      }
      
      plen += n;
   }

   /* FIXME: report if n < 0 as well */
   if (plen == BUF_SIZE - 2)
   {
      /* password too long! */
      printf("Error: too much to read from stdin!\n");
      memset(buf, 0, plen);
      exit(1);
   }

   /* write the password to the tty */
   buf[plen++] = '\n';
   for (pw = 0; pw < plen;)
   {
      n = write(pty_fd, buf + pw, plen - pw);
      if (n <= 0)
      {
         break;
      }

      pw += n;
   }

   memset(buf, 0, plen);

   /* FIXME: report if n < 0 as well */
   if (pw < plen)
   {
      /* unable to write all of password to the tty */
      printf("Error: unable to write password to tty!\n");
      exit(1);
   }
}

