/*
 * this uses some ideas borrowed from IzPack
 */


/*
 *
 */
package installer.common;


/*
 *
 */
import javax.swing.JPanel;


/*
 *
 */
public abstract class InstallerPanel
{
    /*
     * FIXME: this should probably be a singleton...
     */
    protected InstallerGUI gui;

    /*
     *
     */
    protected final JPanel panel;


    /*
     *
     */
    public InstallerPanel()
    {
        this.gui = null;
        this.panel = new JPanel();
    }


    /*
     * FIXME: would prefer to have an installPanelInWindow()
     *        method, that takes a specialized interface provided
     *        by InstallerWindow
     */
    public final JPanel getJPanel()
    {
        return this.panel;
    }


    /*
     * called by InstallerWindow, upon loading, after the JPanel
     * has been added to the container and made visible
     */
    public abstract void postload(Controller nativeController,
                                  InstallerWindow.NavUpdateListener navUpdateListener);

    /*
     * called by InstallerWindow, upon loading, before the JPanel
     * has been added to the container
     */
    public abstract void preload();


    /*
     * FIXME: it's probably better to make InstallerGUI a singleton
     */
    public void setGUI(InstallerGUI installerGUI)
    {
        this.gui = installerGUI;
    }


    /*
     * return true if the unloading is successful;
     * otherwise, false. in the latter case, the
     * owning frame should not switch to another panel
     */
    public abstract boolean unload();
}

