/*
 *
 */


/*
 *
 */
package installer.common;


/*
 *
 */
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.EventQueue;
import java.util.logging.Handler;
import java.util.logging.Logger;
import java.util.logging.LogRecord;
import javax.swing.JFrame;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.WindowConstants;


/*
 *
 */
public class LogWindow
{
    /*
     *
     */
    protected JFrame frame;
    protected JTextArea textArea;
    protected JScrollPane textAreaScrollPane;


    /*
     *
     */
    public LogWindow(String title,
                     Logger logger)
    {
        this.frame = new JFrame(title);
        this.textArea = new JTextArea();
        this.textAreaScrollPane = new JScrollPane(this.textArea);
        
        this.frame.getContentPane().add(this.textAreaScrollPane, BorderLayout.CENTER);
        this.frame.setSize(320, 480);

        // FIXME: actually, it should be possible to close this window, and we should
        //        then signal back to the main window that it was closed (e.g. so it
        //        can change the "View/Hide Log" button)
        this.frame.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);

        logger.addHandler(new Handler() {
                public void close()
                {
                }
                
                public void flush()
                {
                }

                public void publish(final LogRecord record)
                {
                    EventQueue.invokeLater(new Runnable()
                        {
                            public void run()
                            {
                                addText(record.getMessage());
                            }
                        });
                }
            });
    }


    /*
     *
     */
    private void addText(String text)
    {
        boolean paneIsScrolledToBottom;
        JScrollBar vBar;


        // FIXME: this doesn't quite work right; the caret moves
        //        to the bottom-rightmost, but we want it to move
        //        to the bottom-leftmost
        
        vBar = this.textAreaScrollPane.getVerticalScrollBar();
        paneIsScrolledToBottom = vBar.getValue() + vBar.getVisibleAmount() == vBar.getMaximum();
        
        this.textArea.append(text);
        this.textArea.setCaretPosition(this.textArea.getDocument().getLength());
    }


    /*
     *
     */
    public void dispose()
    {
        this.frame.dispose();
    }


    /*
     *
     */
    public void hide()
    {
        this.frame.setVisible(false);
    }


    /*
     *
     */
    public void show()
    {
        this.frame.setVisible(true);
    }
}
