/*
 * even per-system, there may be several ways to run matlab, and
 * it may be that no one method is the "common denominator." this
 * is an interface that abstracts the process of running matlab
 * and gathering its output.
 */


/*
 *
 */
package installer.common;


/*
 *
 */
import java.io.File;
import java.io.IOException;

import installer.common.ProcessExecutionException;
import installer.common.ProcessOutputAnalyzer;


/*
 *
 */
public abstract class MatlabRunner
{
    /*
     *
     */
    public abstract <ResultType> ResultType
        run(File matlabPath,
            String matlabCommand,
            File logFile,
            ProcessOutputAnalyzer<ResultType> outputAnalyzer)
        throws IOException,
               ProcessExecutionException;


    /*
     * FIXMEFIXME: remove this
     * the default version of run(): just capture the last
     * line of the output as a String
     */
    public String run(File matlabPath,
                      String matlabCommand,
                      File logFile)
        throws IOException,
               ProcessExecutionException
    {
        return run(matlabPath, matlabCommand, logFile, new ProcessOutputAnalyzer.LastLine());
    }
}

