/*
 *
 */


/*
 *
 */
package installer.common;


/*
 *
 */
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.util.logging.Logger; // DEBUG
import javax.swing.JScrollPane;


/*
 * essentially a container to keep its single child widget constrained
 * horizontally (i.e. the scroll pane should only let it scroll up and
 * down, not left and right)
 *
 * FIXME: this may have rounding issues
 */
public class VertScrollWidget<WidgetType extends Component>
    extends JScrollPane implements ComponentListener
{
    /*
     *
     */
    private static class WidthConstrainedContainer extends Container
    {
        //
        public int constrainedWidth = Integer.MAX_VALUE;

        //
        public WidthConstrainedContainer(Component component)
        {
            setLayout(new BorderLayout());
            add(component, BorderLayout.CENTER);
        }

        //
        public Dimension getPreferredSize()
        {
            Dimension defaultPrefSize = super.getPreferredSize();
            
            return new Dimension((int) Math.min(constrainedWidth, defaultPrefSize.getWidth()),
                                 (int) defaultPrefSize.getHeight());
        }
    }


    /*
     *
     */
    private final WidthConstrainedContainer widgetContainer;


    /*
     *
     */
    public VertScrollWidget(WidgetType containedWidget)
    {
        // FIXME: does not work with VERTICAL_SCROLLBAR_AS_NEEDED. i hate swing.
        super(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
              JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);

        this.widgetContainer = new WidthConstrainedContainer(containedWidget);
        setViewportView(this.widgetContainer);

        addComponentListener(this);
    }


    /*
     *
     */
    public void componentHidden(ComponentEvent event)
    {
    }


    /*
     *
     */
    public void componentMoved(ComponentEvent event)
    {
    }


    /*
     *
     */
    public void componentResized(ComponentEvent event)
    {
        this.widgetContainer.constrainedWidth = (int) getViewport().getSize().getWidth();
    }

    
    /*
     *
     */
    public void componentShown(ComponentEvent event)
    {
    }
}

