/*
 *
 */


/*
 *
 */
import java.lang.Class;
import java.lang.ClassLoader;
import java.lang.reflect.InvocationTargetException;
import java.util.*;
import wfdb.*;


/*
 *
 */
public class rdannMatlab
{
    /*
     *
     */
    static
    {
        try
        {
            Class nativeLibLoader
                = ClassLoader.getSystemClassLoader().loadClass("NativeLibLoader");
            nativeLibLoader.getMethod("loadLibraries", null).invoke(null, null);
        }
        catch (ClassNotFoundException ex)
        {
        }
        catch (NoSuchMethodException ex)
        {
        }
        catch (IllegalAccessException ex)
        {
        }
        catch (InvocationTargetException ex)
        {
        }
    }


    // /*
    //  * FIXME: these could be better named...
    //  */
    // public enum TimeOutputFormat
    // {
    //     NORMAL_FORMAT,
    //     ELAPSED_TIME_FORMAT,
    //     ALTERNATE_FORMAT
    // }


    // /*
    //  * this is used essentially as a struct
    //  */
    // public static class Annotation
    // {
    //     public double timeInSeconds;
    //     public int sampleNumber;
    //     public String typeMnemonic;
    //     public int subtype;
    //     public int chan;
    //     public int num;
    //     public String auxInfo;
    // }


    /*
     * FIXME: get rid of the bytes
     *
     * the starting time is unspecified when startTime is null or has length 0;
     * similarly, the ending time is unspecified when stopTime is null or has length 0
     */
    public static Annotation[] rdann(String recordName,             // -r
                                     String annotatorName,          // -a
                                     String startTime,              // -f
                                     String stopTime,               // -t
                                     Byte chan,                     // -c
                                     Byte num,                      // -n
                                     Byte subtype,                  // -s
                                     String[] annotationTypes)      // -p
    {
        double sps, spm, sph;
        int from = 0;
        int to = 0;
        int beatNumber = 0;
        WFDB_Anninfo ai;
        WFDB_Annotation annot;
        boolean[] flag;
        int i, j;
        Vector outputRows;
        

        // initialize data structures
        ai = new WFDB_Anninfo();
        annot = new WFDB_Annotation();
        for (i = 0, flag = new boolean[wfdb.ACMAX + 1]; i < flag.length; ++i)
        {
            flag[i] = false;
        }
        flag[0] = true;

        //
        if (annotationTypes != null)
        {
            for (i = 0; i < annotationTypes.length; ++i)
            {
                j = wfdb.strann(annotationTypes[i]);
                if (wfdb.wfdb_isann(j) != 0)
                {
                    flag[j] = true;
                }
            }
            flag[0] = false;
        }
                
        //
        sps = wfdb.sampfreq(recordName);
        if (sps < 0.0)
        {
            sps = wfdb.WFDB_DEFFREQ;
            wfdb.setsampfreq(sps);
        }
        spm = 60.0 * sps;
        sph = 60.0 * spm;

        // open annotation file
        ai.setName(annotatorName);
        ai.setStat(wfdb.WFDB_READ);
        if (wfdb.annopen(recordName, ai, 1) < 0)
        {
            wfdb.wfdbquit();
            return null;
        }

        //
        if (startTime != null && startTime.length() > 0)
        {
            if (startTime.charAt(0) == '#')
            {
                try
                {
                    beatNumber = Integer.parseInt(startTime.substring(1));
                }
                catch (NumberFormatException ex)
                {
                    beatNumber = 0;
                }

                if (beatNumber < 0)
                {
                    beatNumber = 0;
                }

                while (beatNumber > 0 && wfdb.getann(0, annot) == 0)
                {
                    if (wfdb.wfdb_isqrs(annot.getAnntyp()) > 0)
                    {
                        --beatNumber;
                    }
                }

                if (beatNumber > 0)
                {
                    wfdb.wfdbquit();
                    return null;
                }
            }
            else if (wfdb.iannsettime(wfdb.strtim(startTime)) < 0)
            {
                wfdb.wfdbquit();
                return null;
            }
        }

        //
        if (stopTime != null && stopTime.length() > 0)
        {
            if (stopTime.charAt(0) == '#')
            {
                try
                {
                    beatNumber = Integer.parseInt(stopTime.substring(1));
                }
                catch (NumberFormatException ex)
                {
                    beatNumber = 1;
                }

                if (beatNumber < 1)
                {
                    beatNumber = 1;
                }

                to = 0;
            }
            else
            {
                beatNumber = -1;
                to = wfdb.strtim(stopTime);
                if (to < 0) {
                    to = -to;
                }
            }
        }

        //
        outputRows = new Vector();

        //
        while (wfdb.getann(0, annot) == 0
               && (to == 0 || annot.getTime() <= to))
        {
            if ((flag[0] || (wfdb.wfdb_isann(annot.getAnntyp()) != 0 && flag[annot.getAnntyp()]))
                && (chan == null || annot.getChan() == chan.byteValue())
                && (num == null || annot.getNum() == num.byteValue())
                && (subtype == null || annot.getSubtyp() == subtype.byteValue()))
            {
                Annotation annotRow = new Annotation();

                //
                annotRow.timeInSeconds = annot.getTime() / sps;
                annotRow.sampleNumber = annot.getTime();
                annotRow.typeMnemonic = wfdb.annstr(annot.getAnntyp());
                annotRow.subtype = annot.getSubtyp();
                annotRow.chan = annot.getChan();
                annotRow.num = annot.getNum();
                annotRow.auxInfo = (annot.getAux() != null) ? annot.getAux().substring(1) : null;
                
                //
                outputRows.add(annotRow);
            }

            if (beatNumber > 0
                && wfdb.wfdb_isqrs(annot.getAnntyp()) != 0
                && --beatNumber == 0)
            {
                break;
            }
        }
        
        //
        return (Annotation[]) outputRows.toArray(new Annotation[outputRows.size()]);
    }

}

