/*
 *
 */


/*
 *
 */
import java.lang.Class;
import java.lang.ClassLoader;
import java.lang.reflect.InvocationTargetException;
import java.util.Random;
import wfdb.*;


/*
 *
 */
public class wrsampMatlab
{
    /*
     *
     */
    static
    {
        try
        {
            Class nativeLibLoader
                = ClassLoader.getSystemClassLoader().loadClass("NativeLibLoader");
            nativeLibLoader.getMethod("loadLibraries", null).invoke(null, null);
        }
        catch (ClassNotFoundException ex)
        {
        }
        catch (NoSuchMethodException ex)
        {
        }
        catch (IllegalAccessException ex)
        {
        }
        catch (InvocationTargetException ex)
        {
        }
    }


    /*
     * Note that this does not deterministically match the CLI app.,
     * and it is also implemented (very) slightly differently.
     */
    protected static double dither(Random randObj)
    {
        return randObj.nextDouble() + randObj.nextDouble() - 1.0;
    }


    /*
     * Command-line app. flags -c, -h, -l, -r, and -s are irrelevant
     * here.
     *
     * Note that this code does not do any column reordering, as the
     * command-line app. must, because the columns are expected to be
     * given in the order in which they're written out.
     *
     * FIXME: fix this description
     * The sizes of inputColumns, gain, and scale should all be the
     * same.
     *
     * outputRecordName should be non-null
     *
     * inputName corresponds to -i, but it is not actually used to
     * specify an input file; it is used only as a name to be placed
     * in the description (in the output header file). It may be null.
     *
     * If stopLine is not positive, then it is ignored.
     *
     * FIXME: because column permutations are not allowed in the same
     *        way as with the CLI app., the column numbers printed in
     *        the description (in the output header) are always just
     *        in order up from 0, as in 0, 1, 2, etc. This may be a
     *        slight problem; it could be fixed by taking an additional,
     *        optional "permutation" array, giving indices into
     *        the input-columns argument.
     *
     * FIXME: accept any lengths of gain, scale, INCLUDING ZERO!
     *
     * FIXME: report errors well (somehow)
     * FIXME: yes, really!!!
     */
    public static void wrsamp(double[][] inputColumns, // FIXME: transpose!
                              String outputRecordName,  // -o
                              String inputName,         // -i
                              boolean doDithering,      // -d
                              int startLine,            // -f
                              int stopLine,             // -t
                              double frequency,         // -F
                              double[] gain,            // -G
                              double[] scale)           // -x
    {
        String ofname;
        double[] scalef;
        WFDB_SampleArray vout;
        WFDB_SiginfoArray si;
        int nf = 0;
        double v;
        Random randObj = null;
        int numLines;
        int i, t;


        //
        if (inputColumns == null || inputColumns.length < 1)
        {
            // FIXME: throw exception
            wfdb.wfdbquit();
            return;
        }

        //
        nf = inputColumns[0].length;
        numLines = inputColumns.length;

        //
        if (nf < 1)
        {
            wfdb.wfdbquit();
            return;
        }

        //
        if (gain == null || gain.length == 0)
        {
            wfdb.wfdbquit();
            return;
        }

        //
        if (scale == null || scale.length == 0)
        {
            wfdb.wfdbquit();
            return;
        }

        //
        if (outputRecordName == null)
        {
            // FIXME: this is an error
            wfdb.wfdbquit();
            return;
        }
        else
        {
            ofname = outputRecordName + ".dat";
        }

        //
        vout = new WFDB_SampleArray(nf);
        si = new WFDB_SiginfoArray(nf);
        scalef = new double[nf];

        //
        for (i = 0; i < nf; ++i)
        {
            WFDB_Siginfo siItem = si.getitem(i);

            siItem.setFname(ofname);

            if (inputName == null)
            {
                siItem.setDesc("column " + i);
            }
            else
            {
                siItem.setDesc(inputName + ", column " + i);
            }

            siItem.setUnits("");
            siItem.setGroup(0);
            siItem.setFmt(16);
            siItem.setBsize(0);
            siItem.setAdcres(wfdb.WFDB_DEFRES);
            siItem.setAdczero(0);
            siItem.setBaseline(0);

            if (i >= gain.length)
            {
                // FIXME: optimize this
                siItem.setGain(si.getitem(i-1).getGain());
            }
            else
            {
                siItem.setGain(gain[i]);
            }

            if (i >= scale.length)
            {
                scalef[i] = scalef[i-1];
            }
            else
            {
                scalef[i] = scale[i];
            }

            si.setitem(i, siItem);
        }

        //
        if (wfdb.osigfopen(si.cast(), nf) < nf || wfdb.setsampfreq(frequency) < 0)
        {
            wfdb.wfdbquit();
            return;
        }

        //
        if (doDithering)
        {
            randObj = new Random();
        }

        // read and copy input
        t = 0;
        do
        {
            //
            if (t >= stopLine && stopLine > 0)
            {
                break;
            }

            //
            if (t < startLine)
            {
                ++t;
                continue;
            }

            //
            for (i = 0; i < nf; ++i)
            {
                v = inputColumns[t][i];
                if (Double.isNaN(v))
                {
                    vout.setitem(i, wfdb.WFDB_INVALID_SAMPLE);
                }
                else
                {
                    v *= scalef[i];
                    if (doDithering)
                    {
                        v += dither(randObj);
                    }

                    // FIXME: use java rounding?
                    if (v >= 0.0)
                    {
                        vout.setitem(i, (int)(v + 0.5));
                    }
                    else
                    {
                        vout.setitem(i, (int)(v - 0.5));
                    }
                }
            }

            // FIXME: what does this indicate?
            if (wfdb.putvec(vout.cast()) < 0)
            {
                break;
            }

            ++t;
        }
        while (t < numLines);

        // FIXME: outputRecordName should be verified as not null, probably
        if (outputRecordName != null)
        {
            wfdb.newheader(outputRecordName);
        }

        wfdb.wfdbquit();
        return;
    }

}

